{-# LANGUAGE FlexibleContexts,
             ImpredicativeTypes,
             NoMonomorphismRestriction
 #-}

module MemoizedFib3 (fib) where
import qualified AOP.Examples.Fib3 as Fib
import AOP.Default
import Data.Map
import Control.Monad.Error

memo :: Ord a => NIAdvice (StateT (Map a b)) a b
memo proceed n =
     do m <- get
        if member n m
        then return (m ! n)
        else do y <- proceed n
                m' <- get
                put (insert n y m')
                return y

fib = let preAspect = pAspect Fib.ppcFib --makes inference work
      in do deploy (preAspect memo)
            Fib.fib 

runMemo c = runIdentity (runErrorT (evalStateT (runNIAOT c) empty))

program n = runMemo $ do f <- fib
                         f # n
